'use strict';

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

const promisify = require('@quarterto/promisify');
const mkTempDir = promisify(require('temp').track().mkdir);
const spawn = require('cross-spawn-promise');

module.exports = (() => {
	var _ref = (0, _asyncToGenerator3.default)(function* (remote, commitish, dirName) {
		const dir = yield mkTempDir(dirName || 'heroku-version-infer');
		yield spawn('git', ['clone', '--bare', remote, dir]);

		const oldDir = process.cwd();
		process.chdir(dir);

		try {
			const shaResult = yield spawn('git', ['rev-list', '--max-count=1', commitish]);
			const sha = shaResult.toString().trim();

			const mergesResult = yield spawn('git', ['rev-list', sha, '--merges', '--first-parent']);
			const merges = mergesResult.toString().split('\n').length;

			return `${ merges }.0.0-heroku-${ sha.substr(0, 7) }`;
		} finally {
			process.chdir(oldDir);
		}
	});

	function infer(_x, _x2, _x3) {
		return _ref.apply(this, arguments);
	}

	return infer;
})();
